<?php
/**
 * 会員専用ページ
 * 
 */
require_once (dirname(__FILE__) . "/FRONT_Controller.php");

class Mypage extends FRONT_Controller {
    
    private $member = null;
    
    function Mypage()
    {
        parent::FRONT_Controller();
        $this->load->model('Common_model');
        $this->load->model('Res_model');
        $this->load->model('Hotel_model');
        
        // ログインチェック
        $this->load->helper('url');
        $this->load->library('phpsession');
        $this->member = $this->phpsession->get('member');
        if (is_null($this->member))
        {
            redirect('login/login');
        }
    }
    
    /**
     * 予約リストを表示する
     */
    function index($hotelid)
    {
        $this->load->library('phpsession');
        $this->load->helper(array('form', 'url'));
        
        // ユーザの予約リストを得る
        $this->db->where('memberid', $this->member['memberid']);
        $this->db->where('status', 2);  // 本予約のみ
        $this->db->order_by('created', 'desc');
        $query = $this->db->get('reservation');
        
        $data['ress'] = $query->result_array();
        $this->load->vars($data);
        
        $this->load->view('mypage/index');
    }
    
    /**
     * 予約詳細
     */
    public function resdetail($hotelid, $resid)
    {
        // 予約詳細をみる
        $this->db->where('resid', $resid);
        $query = $this->db->get('reservation');
        if ($query->num_rows() <= 0)
        {
            die('resid is not set');
        }
        
        $row = $query->row_array();
        $data = $row;
        $this->load->vars($data);
        
        if ($data['memberid'] != $this->member['memberid'])
        {
            die('memberid error');
        }
        
        $this->db->where('resid', $resid);
        $this->db->where('status >', 0);
        $query = $this->db->get('reservation', 1);
        if ($query->num_rows() <= 0)
        {
            die('reservation is not found.');
        }
        $reservation = $query->row_array();
        
        $this->db->where('resid', $resid);
        $query = $this->db->get('resmember', 1);
        if ($query->num_rows() <= 0)
        {
            die('resmember is not found.');
        }
        $resmember = $query->row_array();
        
        $planid = $reservation['planid'];
        $roomtypeid = $reservation['roomtypeid'];
        $this->db->where('planid', $planid);
        $query = $this->db->get('plans', 1);
        if ($query->num_rows() <= 0)
        {
            die('plan is not found.');
        }
        $plan = $query->row_array();
        
        $this->db->where('roomtypeid', $roomtypeid);
        $query = $this->db->get('roomtypes', 1);
        if ($query->num_rows() <= 0)
        {
            die('roomtype is not found.');
        }
        $roomtype = $query->row_array();
        
        $this->db->where('resid', $resid);
        $this->db->order_by('day DESC');
        $query = $this->db->get('resrooms');
        if ($query->num_rows() <= 0)
        {
            die('resrooms is not found.');
        }
        $resrooms = $query->result_array();
        
        $this->db->where('resid', $resid);
        $this->db->order_by('day DESC');
        $query = $this->db->get('resoptions');
        if ($query->num_rows() <= 0)
        {
            $resoptions = array();
        }
        else
        {
            $resoptions = $query->result_array();
        }
        
        ob_start();
        
        echo '<table class="inp">' . "\n";
        
        echo "<tr><th>予約コード : </th><td>" . $reservation['rescode'] . "</td></tr>\n";
        echo "<tr><th>予約受付日 : </th><td>" . $reservation['created'] . "</td></tr>\n";
        echo "<tr><th>チェックイン日 : </th><td>" . $reservation['cin'] . ' (' . $this->Common_model->week($reservation['cin']) . ')' . "</td></tr>\n";
        echo "<tr><th>チェックアウト日 : </th><td>" . $reservation['cout'] . ' (' . $this->Common_model->week($reservation['cout']) . ')' . "</td></tr>\n";
        echo "<tr><th>宿泊日数 : </th><td>" . $reservation['stay_days'] . ' 日' . "</td></tr>\n";
        echo "<tr><th>プラン名 : </th><td>" . $plan['plan_name'] . "</td></tr>\n";
        echo "<tr><th>部屋タイプ : </th><td>" . $roomtype['roomtype_name'] . "</td></tr>\n";
        echo "<tr><th>部屋数 : </th><td>" . $reservation['room_num'] . " 部屋" . "</td></tr>\n";
        echo "<tr><th>人数 : </th><td>" . "\n";
        
        $tmp = '';
        for ($i = 0; $i < $reservation['room_num']; $i++)
        {
            $resroom = $resrooms[$i];
            echo $resroom['room_no'] . '部屋目' . "<br />\n";
            if ($resroom['basic_num'] > 0)
            {
                echo "・大人 : "  . $resroom['basic_num']  . " 人 ";
            }
            if ($resroom['child1_num'] > 0)
            {
                echo "・子供A : " . $resroom['child1_num'] . " 人 ";
            }
            if ($resroom['child2_num'] > 0)
            {
                echo "・子供B : " . $resroom['child2_num'] . " 人 ";
            }
            if ($resroom['child3_num'] > 0)
            {
                echo "・子供C : " . $resroom['child3_num'] . " 人 ";
            }
            if ($resroom['child4_num'] > 0)
            {
                echo "・子供D : " . $resroom['child4_num'] . " 人 ";
            }
            echo "<br />\n";
        }
        echo "</td></tr>\n";
        
        echo "<tr><th>料金 : </th><td>" . "\n";
        
        $tmp = '';
        $strDay = '';
        foreach ($resrooms as $resroom)
        {
            if ($strDay != $resroom['day'])
            {
                echo $resroom['day'] . "<br />\n";
                $strDay = $resroom['day'];
            }
            echo $resroom['room_no'] . '部屋目' . "<br />\n";
            if ($resroom['basic_num'] > 0)
            {
                echo "・大人 : ";
                $temp = $resroom['basic_num'] * $resroom['basic_price'];
                echo $resroom['basic_num'] . ' 人 x ' . number_format($resroom['basic_price']) . ' 円 = ' . number_format($temp) . ' 円' . "<br />\n";
            }
            if ($resroom['child1_num'] > 0)
            {
                echo "・子供A : ";
                $temp = $resroom['child1_num'] * $resrooom['child1_price'];
                echo $resroom['child1_num'] . ' 人 x ' . number_format($resroom['child1_price']) . ' 円 = ' . number_format($temp) . ' 円' . "<br />\n";
            }
            if ($resroom['child2_num'] > 0)
            {
                echo "・子供B : ";
                $temp = $resroom['child2_num'] * $resroom['child2_price'];
                echo $resroom['child2_num'] . ' 人 x ' . number_format($resroom['child2_price']) . ' 円 = ' . number_format($temp) . ' 円' . "<br />\n";
            }
            if ($resroom['child3_num'] > 0)
            {
                echo "・子供C : ";
                $temp = $resroom['child3_num'] * $resroom['child3_price'];
                echo $resroom['child3_num'] . ' 人 x ' . number_format($room_i['child3_price']) . ' 円 = ' . number_format($temp) . ' 円' . "<br />\n";
            }
            if ($resroom['child4_num'] > 0)
            {
                echo "・子供D : ";
                $temp = $resroom['child4_num'] * $resroom['child4_price'];
                echo $resroom['child4_num'] . ' 人 x ' . number_format($room_i['child4_price']) . ' 円 = ' . number_format($temp) . ' 円' . "<br />\n";
            }
        }
        echo "</td></tr>\n";
        
        if (count($resoptions) > 0)
        {
            echo "<tr><th>オプション : </th><td>" . "\n";
            
            $tmp = '';
            $strDay = '';
            
            $tmp = '';
            $strDay = '';
            foreach ($resoptions as $resoption)
            {
                if ($strDay != $resoption['day'])
                {
                    echo $resoption['day'] . "<br />\n";
                    $strDay = $resoption['day'];
                }
                echo '・' . $resoption['option_name'] . ':';
                echo number_format($resoption['price']) . '円' . " x ";
                echo $resoption['num'] . " " . $resoption['unitname'] . " = ";
                $option_subtotal = $resoption['price'] * $resoption['num'];
                echo number_format($option_subtotal) . '円' . "<br />\n";
            }
            echo "</td></tr>\n";
        }
        
        echo "<tr><th>合計 : </th><td>" . number_format($reservation['total_price']) . "円" . "</td></tr>\n";
        echo "<tr><th>申込者氏名: </th><td>" . $resmember['name'] . "</td></tr>\n";
        echo "</table>\n";
        
        $data['contents'] = ob_get_contents();
        ob_end_clean();
        $this->load->vars($data);
        
        $this->load->view('mypage/resdetail');
    }
    
    /**
     * 予約キャンセル
     */
    public function rescancel($hotelid, $resid)
    {
        // 予約詳細をみる
        $this->db->where('resid', $resid);
        $query = $this->db->get('reservation');
        if ($query->num_rows() <= 0)
        {
            die();
        }
        $row = $query->row_array();
        $data = $row;
        if ($data['memberid'] != $this->member['memberid'])
        {
            die();
        }
        
        $this->Res_model->cancel($resid, 1, $this->Hotel_model);
        
        $this->load->view('mypage/rescancel');
    }
    
    /**
     * 会員情報の表示
     */
    public function memberinfo($hotelid)
    {
        $this->db->where('memberid', $this->member['memberid']);
        $query = $this->db->get('members');
        if ($query->num_rows() > 0)
        {
            $row = $query->row_array();
            $data = $row;
            $this->load->vars($data);
        }
        $this->load->view('mypage/memberinfo');
    }
    
    /**
     * 会員情報の編集
     */
    public function memberedit($hotelid)
    {
        $this->load->helper(array('MY_form', 'MY_url'));
        
        $this->load->library('form_validation');
        $this->form_validation->set_error_delimiters('<div class="error">', '</div>');
        
        $this->form_validation->set_rules('email', 'メールアドレス', 'required|valid_email|trim|xss_clean');
        $this->form_validation->set_rules('password', 'パスワード', 'trim|xss_clean');
        $this->form_validation->set_rules('name', '氏名', 'required|trim|xss_clean');
        $this->form_validation->set_rules('name_kana', '氏名(かな)', 'required|trim|xss_clean|callback_hiragana_check');
        $this->form_validation->set_rules('postcode', '郵便番号', 'required|trim|xss_clean|callback_postcode_check');
        $this->form_validation->set_rules('prefecture', '都道府県', 'required|trim|xss_clean');
        $this->form_validation->set_rules('city', '市区町村', 'required|trim|xss_clean');
        $this->form_validation->set_rules('street', '番地', 'required|trim|xss_clean');
        $this->form_validation->set_rules('phone', '電話番号', 'required|trim|xss_clean|callback_phone_check');
        
        if (!$this->input->post('submit'))
        {
            $this->db->where('memberid', $this->member['memberid']);
            $query = $this->db->get('members', 1);
            if ($query->num_rows() > 0)
            {
                $data = $query->row_array();
                $data['password'] = '';
                $this->load->vars($data);
            }
        }
        
        if ($this->form_validation->run() == FALSE)
        {
            //echo "Form First Or NG";
            $this->load->view('mypage/memberedit');
        }
        else
        {
            // 同じEメールアドレスが登録済みでないことをチェックする
            $this->db->where('email', set_value('email'));
            $this->db->where('hotelid', $hotelid);                          // 同じホテル
            $this->db->where('memberid <> ', $this->member['memberid']);    // 自分以外
            $this->db->where('status > ', 0);
            $query = $this->db->get('members', 1);
            if ($query->num_rows() > 0)
            {
                $data['error'] = array();
                $data['error'][] = '同じEメールアドレスがすでに登録されています。';
                $this->load->vars($data);
                $this->load->view('mypage/memberedit');
                return;
            }
            
            $data = array(
                           'email' => set_value('email'),
                           'password' => sha1(set_value('password')),
                           'name' => set_value('name'),
                           'name_kana' => set_value('name_kana'),
                           'postcode' => set_value('postcode'),
                           'prefecture' => set_value('prefecture'),
                           'city' => set_value('city'),
                           'street' => set_value('street'),
                           'phone' => set_value('phone')
                        );
            $this->db->where('memberid', $this->member['memberid']);
            $this->db->update('members', $data);
            
            if (set_value('password') != '')
            {
                $data = array('password' => sha1(set_value('password')));
                $this->db->where('memberid', $this->user['memberid']);
                $this->db->update('members', $data);
            }
        }
        
        $this->load->view('mypage/memberedit');
    }
    
    /**
     * 退会
     */
    public function unregister($hotelid)
    {
        $data = array('status' => -1);
        $this->db->where('memberid', $this->member['memberid']);
        $this->db->update('members', $data);
        
        // ログアウト処理
        $this->load->library('phpsession');
        $this->phpsession->clear('user');
        
        $this->load->view('mypage/unregister');
    }
}
